java.lang.annotation

## Enum ElementType

- java.lang.Object
- - java.lang.Enum<ElementType>
  - - java.lang.annotation.ElementType

- All Implemented Interfaces:
    Serializable, Comparable<ElementType>

      public enum ElementType
      extends Enum<ElementType>

  A program element type. The constants of this enumerated type provide a simple classification of the declared elements in a Java program.

  These constants are used with the `Target` meta-annotation type to specify where it is legal to use an annotation type.

  Since:
    1.5

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ANNOTATION_TYPE` Annotation type declaration
    `CONSTRUCTOR` Constructor declaration
    `FIELD` Field declaration (includes enum constants)
    `LOCAL_VARIABLE` Local variable declaration
    `METHOD` Method declaration
    `PACKAGE` Package declaration
    `PARAMETER` Parameter declaration
    `TYPE` Class, interface (including annotation type), or enum declaration

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ElementType` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static ElementType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TYPE

          public static final ElementType TYPE

      Class, interface (including annotation type), or enum declaration

    - #### FIELD

          public static final ElementType FIELD

      Field declaration (includes enum constants)

    - #### METHOD

          public static final ElementType METHOD

      Method declaration

    - #### PARAMETER

          public static final ElementType PARAMETER

      Parameter declaration

    - #### CONSTRUCTOR

          public static final ElementType CONSTRUCTOR

      Constructor declaration

    - #### LOCAL_VARIABLE

          public static final ElementType LOCAL_VARIABLE

      Local variable declaration

    - #### ANNOTATION_TYPE

          public static final ElementType ANNOTATION_TYPE

      Annotation type declaration

    - #### PACKAGE

          public static final ElementType PACKAGE

      Package declaration

  - ### Method Detail

    - #### values

          public static ElementType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (ElementType c : ElementType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static ElementType valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.